
$folder = "./txt";
open(O,">instlat.html")||die;

opendir(D,"$folder")||die;
@files = readdir(D);
closedir(D);

for( @files ) {
  next if /^(?:\.+)$/;
  $nam = $_;
  print "[$nam]\n";
  if( open(I,"<$folder/$nam") ) {
    undef $vendor;
    undef $type; $ii=0;
    while(<I>) {
      if( /^CPU#000 Vendor: (.*?) Family: (.*?) Model: (.*?) Stepping: (.*?) / ) {
        $vendor = "$2.$3.$4";
        print "!$1-$vendor!\n";
      }
      if( /^CPU#000 Type: \"(.*?)\"/ ) {
        $type = $1;
        $type =~ s/^\s+//;
        $type =~ s/\s+$//;
        $type = "($vendor) $type";

$type = "<p style=\"color:#C00000\">$type</p>" if $type=~/AMD/;
$type = "<p style=\"color:#0000C0\">$type</p>" if $type=~/Intel/;

        print "!$type!\n"; ++$n_cpu;
      }
      if( /^([ \d]{4}) ([^:]*):(.*?) ((?:L:|BW)[^\x00-\x1F]*)/ ) {
        ($idx,$iset,$ins,$lat) = ($1,$2,$3,$4);
        $idx = $idx+0;
        $iset =~ s/\s+$//;
        $ins =~ s/\s+$//;
        $lat =~ s/^\s+//;
        $lat =~ s/\s+$//;
        $lat =~ s/ \[no true dep\.\]/c/;
        $lat =~ s/ \[memory dep\.\]/mem/;
        if( $lat =~ s/(?:\s+)(?:[\d\.]+)ns=\s*//g ) {
          $lat =~ s/\.(?:0+)c/c/g;
          $lat =~ s/\.(\d+)(?:0+)c/.$1c/g;
#          $lat =~ s/(?:0+)c/c/g;
          $lat =~ s/L:/L=/;
          $lat =~ s/T:/T=/;
        }
        $lat =~ s/\=c/\=0c/g;
        $ins1 = "$iset! $ins";
#        print "!$idx!$ins1!$lat!\n";
        $isa{$iset}=1;
        $rank{$ins1}+=sprintf("%i.%04i",$idx,$ii++);
        $rnum{$ins1}+=1;
        $ilat{$ins1}.="\n$type!$lat";
      }
    }
    close I;
  }
}

#open(O,">log.txt")||die;
for( sort keys %rank ) {
  $rx{$rank{$_}/$rnum{$_}}=$_;
  ++$n_ins;
}
for( sort {$a<=>$b} keys %rx ) {
  $s = $rx{$_};
#  printf O "!%s!%s!%s!\n", $_, $s, $ilat{$s};
}
#close O;

open(I,"<sets.txt")||die;
while(<I>){
  if( /^([\-\+])([^\x00-\x1F]*)/ ) {
#    print "$1!$2\n";
    $a=$2; $b=$2; $c=$1;
    $en{$a}="";
    $en{$a}="checked" if $c eq "+";
    $a=~s/\./_/g;
    $cv{$b}="_$a";
    $di{$a}="";
    $di{$a}="\._$a\{display:none\}" if $c ne "+";;
  }
}
close I;

$ss="";
$cb="";
$j=0;
for( sort keys %isa ) {
#  $ss .= "<style type=\"text/css\">.$_\{\}</style>\n";
  $ss .= "<style type=\"text/css\">$di{$_}</style>\n";
  $cb .= sprintf("<input type=checkbox %s onclick=\"cb('$cv{$_}',%i)\"><b>$_<b>\n", $en{$_}, $j+1);
  $cb .= "<br>" if $j%8==7;
  $j++;
}


@cls=("#D0FFD0","#D0D0FF");

$head=<<TEXT;
<html>
<head>
<title>InstLat comparison chart</title>
</head>
<style type="text/css">
  body {
    margin-top:.25em; margin-bottom:.25em;
    margin-left: 5%; margin-right:10%;
    text-indent:1em;
    cursor: default;
    font-family:monospace; font-style:normal;
    letter-spacing: -0.6pt;
  }
  .a { background-color:#D0FFD0; }
  .b { background-color:#D0D0FF; }
  .c { background-color:#D0D0D0; }
  .d { display:none; }
</style>

$ss

<script>

function toggle( s ) {
  if( document.getElementById(s).style.display ) {
    document.getElementById(s).style.display = "";
  } else {
    document.getElementById(s).style.display = "none";
  }
}

function tgl( s1 ) {
  toggle( 'a'+s1 );
}

function cb( s1, j ) {
  if( document.getElementsByTagName('style')[j].innerHTML ) {
    document.getElementsByTagName('style')[j].innerHTML="";
  } else {
    document.getElementsByTagName('style')[j].innerHTML="."+s1+"{display:none}";
  }
}

</script>

<table width=100% border=1 cellspacing=1 cellpadding=3 style="font-size:9.5pt;white-space:nowrap;">
<tr class=c><th colspan=4>
<h1>**  InstLat comparison chart  ** <br>
** Click on instruction to show timings ** <br>
** Click on checkbox to enable/disable instructions set ** <br></h1>
<br>
$cb
TEXT

$tail=<<TEXT;
<tr class=c><th colspan=4>
Total instructions: $n_ins;  Total CPUs: $n_cpu<br>
**  Script by Eugene Shelwien, timings from <a href="http://instlatx64.atw.hu/">http://instlatx64.atw.hu/</a> ** <br>

</table>

</html>
TEXT


print O $head;

$id=0;
for( sort {$a<=>$b} keys %rx ) {
  my $s = $rx{$_};
  my ($a,$b) = split("!",$s);
  my @l = split('\n',$ilat{$s});
  shift @l;
#  print O $ilat{$s}."\n";
  printf O "<tr class=\"$cv{$a}\" style=\"background-color:%s\" onclick=\"tgl(%i)\"><td><b>%s</b><td colspan=2><b>%s</b></tr>\n", $cls[0], $id, $a, $b;
  printf O "<tbody id=a%i style=\"background-color:%s;display:none\">\n",$id,"#C0C0C0";
  for( @l ) {
    my ($c,$d) = split("!",$_);
    printf O "<tr onclick=\"tgl(%i)\"><td><td>%s<td>%s\n", $id, $c, $d;
  }
  printf O "</tbody>\n";
  push @cls, shift @cls;
  ++$id;
}

print O $tail;

close O;


=rem
open(O,">sets.txt")||die;
for( sort keys %isa ) {
  print O "+$_\n";
}
close O;
=cut

=rem
CPU#000 Vendor: GenuineIntel Family: 6 Model: 55 Stepping: 4 CoreType:0x20050654
CPU#000 Type: "Intel(R) Core(TM) i7-7800X CPU @ 3.50GHz"
2442 AVX512F             :{EVEX} VFMADD213SD xmm, xmm, xmm      L:   1.14ns=  4.0c  T:   0.14ns=  0.50c
=cut
